(* https://github.com/kayceesrk/cs3100_f19/blob/cc71e59a081543257adc72a2428685e891bcd307/assignments/assignment1.ipynb *)

(* cond_dup: 'a list -> ('a -> bool) -> 'a list *)
let cond_dup l f =
  List.fold_right
    (fun a acc ->
      (if f a then a :: a :: acc 
       else a :: acc))
    l []
(* # cond_dup [3;4;5] (fun x -> x mod 2 = 1);; *)
(* - : int list = [3; 3; 4; 5; 5] *)

let rec n_times (f, n, v) =
  if n <= 0 then v
  else n_times (f, n-1, f v)
(* # n_times((fun x-> x+1), 50, 0);; *)
(* - : int = 50 *)

let rec range start stop =
  if stop - start >= 0 then start :: (range (start+1) stop)
  else []
(* # range 2 5;; *)
(* - : int list = [2; 3; 4; 5] *)

let rec zipwith f a b =
  match a, b with
  | [], _
  | _, [] -> []
  | a'::aa, b'::bb -> (f a' b') :: (zipWith f aa bb)
(* # zipwith (+) [1;2;3] [4;5];; *)
(* - : int list = [5; 7] *)

(* let rec flatten l = *)
(*   match l with *)
(*   | [] -> [] *)
(*   | l :: ls -> l @ (flatten ls) *)
let rec flatten = function
  | [] -> []
  | l :: ls -> l @ (flatten ls)
(* # flatten ([[1;2];[3;4]]);; *)
(* - : int list = [1; 2; 3; 4] *)

let remove_stutter l =
  List.fold_right
    (fun x (prev, res) ->
       match prev with
       | None -> (Some x, x::res)
       | Some prev' ->
           if x=prev' then (prev, res)
           else (Some x, x::res))
    l (None, [])
(* # remove_stutter [1;2;2;3;1;1;1;4;4;2;2];; *)
(* - : int option * int list = (Some 1, [1; 2; 3; 1; 4; 2]) *)
